* CSTRG$
*
* pjwitte 2o23+
* All code is my own work except as and where stated
*
* V0.01, pjw, 2023 Jul 03
* V0.02, pjw, 2023 Aug 04, changed limit into skip instead
*
* Compatible with QDOS, Minerva and SMSQ/E
*


        section code

        xdef cstr

        xref lin2flt,fputp

        include dev8_keys_sbasic
        include dev8_keys_qlv
        include dev8_keys_err



*
cstr
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* qstr$ = CSTR$(adr [, skip%])
*
* where
*       adr   is the location of start of the c-string
*             On return this contains the address of the terminating
*             zero + 1 - or err.bffl
*       skip% number of prior c-strings to skip (default 0)
*
* If 32764 characters without terminating 0 is surpassed an error is
* returned in adr
*
* On error, or where the character at adr = 0, a null string is returned.

        move.w sb.gtlin,a2
        jsr (a2)
        bne.s exit

        cmpi.w #2,d3
        beq.s twopar

        subq.w #1,d3
        beq.s onepar

err_bp
        moveq #err.ipar,d0

exit
        rts

onepar
        moveq #0,d3                     d3 = skip num
        moveq #4,d0
        bra.s cont

twopar
        move.l 4(a6,a1.l),d3
        bmi.s err_bp                    cant have negative skip
        moveq #8,d0

cont
        move.l (a6,a1.l),d1
        ble.s err_bp                    cant have negative or zero addr

        add.l d0,sb_arthp(a6)
        move.w #32764,d7                qstring max size!
        moveq #err.bffl,d6              in case we overran limit

        move.l d1,a4

skip
        move.w d7,d4
        move.l a4,d5                    start string

count
        tst.b (a4)+
counte
        dbeq d4,count                   find zero

        beq.s skipe

        move.w d7,d4                    oops! Overshoot. Return zero length
        bra.s bf

skipe
        dbra d3,skip

        move.l a4,d6                    d6 = address to return

bf
        sub.w d4,d7                     d7 = len

        moveq #9,d1                     room for str, len (+ odd), addr
        add.w d7,d1
        bclr #0,d1                      d1 = additional room for return string
        move.l d1,d4

        move.w qa.resri,a2
        jsr (a2)

        sub.l d4,sb_arthp(a6)           grab len (+ 2 + 6) b on stack
        move.l sb_arthp(a6),a1
        add.l #8,a1                     string chars goes here

        move.l d5,a4                    a4 -> cstr
        move.w d7,d2                    d2 = cstr length
        lsr.w #1,d2

mvb
        move.b (a4)+,(a6,a1.l)
        move.b (a4)+,1(a6,a1.l)
        addq.l #2,a1
mvbe
        dbra d2,mvb

        move.l sb_arthp(a6),a1

retstr
        move.l d6,d1                    return value (address) or error
        bsr lin2flt                     convert to float
        bsr fputp                       stuff addr variable

        addq.l #6,a1
        move.l a1,sb_arthp(a6)
        move.w d7,(a6,a1.l)             set length
        moveq #ar.strng,d4              tell SB string return
        moveq #0,d0                     all ok
        rts
*
        end
